#include "01-FederationExecutionTest.hh"
#include "ReturnCodes.hh"

#include <RTI/certiRTI1516.h>
#include <iostream>

int main(int argc, char** argv)
{
	TestFedAmb *fedAmb = new TestFedAmb();

	return fedAmb->execute(argc, argv);
}

TestFedAmb::TestFedAmb()
: rtiAmb(0)
{
}

TestFedAmb::~TestFedAmb()
{
	delete rtiAmb;
}

int TestFedAmb::execute(int argc, char** argv)
{
	std::auto_ptr< rti1516::RTIambassadorFactory > rtiAmbFact(new rti1516::RTIambassadorFactory());
	std::vector< std::wstring > constructorArgs;
	try {
		std::auto_ptr< rti1516::RTIambassador > rtiAmbP(rtiAmbFact->createRTIambassador(constructorArgs));
		rtiAmb = rtiAmbP.release();
	} catch (rti1516::RTIinternalError &e)
	{
		std::wcerr << e.what() << std::endl;
		return certi::rti1516_test::RETURN_ERROR_CREATING_AMBASSADOR;
	}

	try {
		rtiAmb->createFederationExecution(L"Test", L"01.xml");
	} catch (rti1516::Exception &e)
	{
		std::wcerr << e.what() << std::endl;
		return certi::rti1516_test::RETURN_ERROR_CREATING_FEDERATION;
	}


	return 0;
}